﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ContinueWhenAll
{
    class Program
    {
        static int PerformCalculation() { return 42; }

        static void Main(string[] args)
        {
            var TaskA = new Task<int>(() =>
            {
                Console.WriteLine("TaskA wurde gestartet.");
                return PerformCalculation();
            });
            var TaskB = new Task<int>(() =>
            {
                Console.WriteLine("TaskB wurde gestartet.");
                return PerformCalculation();
            });

            var total=Task.Factory.ContinueWhenAll(new Task<int>[] { TaskA, TaskB },
                (tasks) => Console.WriteLine(
                    "Summe = {0}", tasks[0].Result + tasks[1].Result));

            TaskA.Start();
            TaskB.Start();

            Task.WaitAll(TaskA, TaskB);
            total.Wait();

            //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
            //Console.ReadLine();
        }
    }
}
