﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ElternKind
{
    class Program
    {
        static void Main(string[] args)
        {
            Task parent = new Task(() =>
            {
                Console.WriteLine("Eltern-Aufgabe.");
                Task.Factory.StartNew(() => { Thread.Sleep(5000); }, 
                    TaskCreationOptions.AttachedToParent);
            });

            parent.Start();

            if ((!(parent.Wait(2000)) &&
                (parent.Status == TaskStatus.WaitingForChildrenToComplete)))
            {
                Console.WriteLine("Eltern beendet, aber Kind noch nicht fertig.");
                parent.Wait();
            }

            //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
            //Console.ReadLine();
        }
    }
}
