﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ZweiAufgaben_WaitAny
{
    class Program
    {

        static void MethodA() { Thread.SpinWait(int.MaxValue); }
        static void MethodB() { Thread.SpinWait(int.MaxValue/2); }

        static void Main(string[] args)
        {
            var TaskA = Task.Factory.StartNew(MethodA);
            var TaskB = Task.Factory.StartNew(MethodB);

            Console.WriteLine("ID von TaskA = {0}", TaskA.Id);
            Console.WriteLine("ID von TaskB = {0}", TaskB.Id);

            var tasks=new Task[] {TaskA, TaskB};
            int whichTask = Task.WaitAny(tasks);
            Console.WriteLine("Aufgabe {0} hat die Goldmedaille gewonnen.", 
                              tasks[whichTask].Id);

            //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
            //Console.ReadLine();
        }
    }
}
