﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace Zaehlen
{
    class Program
    {
        static int[] intArray = new int[] { 1, 10, 4, 3, 10, 20, 30, 5 };
        static int count = 0;

        static void Main(string[] args)
        {
            Parallel.For(0, intArray.Length, () => 0, (index, loopState, subtotal) =>
                {
                    if (intArray[index] > 5)
                    {
                        ++subtotal;
                        Console.WriteLine("Thread {0}: Aufgabe {1}: Wert {2}, "
                                         + "Teilergebnis {3}",
                            Thread.CurrentThread.ManagedThreadId, index,
                            intArray[index], subtotal);
                    }
                    return subtotal;
                },
                (subtotal) =>
                {
                    Interlocked.Add(ref count, subtotal);
                });

            Console.WriteLine("Ergebnis der Zählung: {0}\n", count);

            //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
            //Console.ReadLine();
        }
    }
}
