﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Publisher
{
    class Book
    {
        public string Publisher { get; set; }
        public string First { get; set; }
        public string Last { get; set; }
        public string Title { get; set; }
        public string ISBN { get; set; }
    }

    class Program
    {
        static void Main(string[] args)
        {
            var books = new[] {new Book{Publisher="Karlsbad Press",
                                        First="David",
                                        Last="Hamilton",
                                        Title="Das David Hamilton-Buch",
                                        ISBN="ISBN-Nummer" },
                               new Book{Publisher="Karlsbad Press",
                                        First="Stefan",
                                        Last="Hesse",
                                        Title="Das Stefan Hesse-Buch",
                                        ISBN="ISBN-Nummer"},
                               new Book{Publisher="Karlsbad Press",
                                        First="Mike",
                                        Last="Ray",
                                        Title="Das Mike Ray-Buch",
                                        ISBN="ISBN-Nummer"},
                                new Book{Publisher="Karlsbad Press",
                                        First="Bento",
                                        Last="Nuno",
                                        Title="Das Bento Nuno-Buch",
                                        ISBN="ISBN-Nummer"}};

            var titles=from book in books.AsParallel() where book.Publisher=="Karlsbad Press" 
                       orderby book.Title select book;

            foreach (Book book in titles)
            {
                Console.WriteLine("{0} {1}: {2}", book.First, book.Last, book.Title);
            }

            //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
            //Console.ReadLine();
        }
    }
}
