﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace MultipleExceptions
{
    class Program
    {
        static void MethodA() { throw new Exception("Ausnahme aus TaskA"); }
        static void MethodB() { throw new Exception("Ausnahme aus TaskB"); }
        static void MethodC() { throw new Exception("Ausnahme aus TaskC"); }

        static void Main(string[] args)
        {
            try {
                var TaskA = Task.Factory.StartNew(MethodA);
                var TaskB = Task.Factory.StartNew(MethodB);
                var TaskC = Task.Factory.StartNew(MethodC);

                // Unbehandelte Ausnahmen werden eingesammelt 
                Task.WaitAll(new Task[] {TaskA, TaskB, TaskC}); 
            }

            catch (AggregateException ae) {
                foreach (var ex in ae.InnerExceptions) {
                    // .. Ausnahmen behandeln
                    Console.WriteLine(ex.Message);
                }
            }

            //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
            //Console.ReadLine();
        }
    }
}
