﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ParalleleSchleifeBreak
{
   class Program
   {
      static void HalfOperation()
      {
         Thread.SpinWait(int.MaxValue / 2);
      }
      
      static void Main(string[] args)
      {
         int cancelValue;

         if (!int.TryParse(args[0], out cancelValue))
         {
            return;
         }

         Parallel.For(0, 20, (index, loopState) =>
         {
            Console.WriteLine("Aufgabe {0} wurde gestartet ...", index);
            HalfOperation();
            if (cancelValue == index)
            {
               loopState.Break();
               Console.WriteLine("Schleife wird beendet. Aufgabe {0} abgebrochen...", index);
               return;
            }
            if (loopState.LowestBreakIteration.HasValue)
            {
               if (index > loopState.LowestBreakIteration)
               {
                  Console.WriteLine("Aufgabe {0} wurde abgebrochen", index);
                  return;
               }
            }
            HalfOperation();
            Console.WriteLine("Aufgabe {0} wurde beendet.", index);
         });
         
         //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
         //Console.ReadLine();
      }

   }
}
