﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ParallelForAusnahmen
{
   class Program
   {
      static void DoSomething()
      {
         Thread.SpinWait(int.MaxValue);
      }

      static void Main(string[] args)
      {
         try
         {
            Parallel.For(0, 6, (index) =>
            {
               Console.WriteLine("Aufgabe {0} wurde gestartet.", index);
               if (index == 4)
               {
                  throw new Exception();
               } 
               DoSomething();
               Console.WriteLine("Aufgabe {0} wurde beendet.", index);
            });
         }
         catch (AggregateException ax)
         {
            Console.WriteLine("\nFehlerliste: \n");
            foreach(var error in ax.InnerExceptions)
            {
               Console.WriteLine(error.Message);
            }
         }	

         //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
         //Console.ReadLine();
      }
   }
}
